Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# ConfigVariableBase Class Reference

This class is the base class for both ConfigVariableList and ConfigVariable (and hence for all of the ConfigVariableBool, ConfigVaribleString, etc. More...

Inheritance diagram for ConfigVariableBase:

List of all members.

## Public Member Functions
bool | clearLocalValue ()
| Removes the local value defined for this variable, and allows its value to be once again retrieved from the .prc files.
string | getDescription ()
| Returns the brief description of this variable, if it has been defined.
int | getFlags ()
| Returns the flags value as set by set_flags().
string | getName ()
| Returns the name of the variable.
int | getTrustLevel ()
| Returns the minimum trust_level a prc file must demonstrate in order to redefine the value for this variable.
ValueType | getValueType ()
| Returns the stated type of this variable.
bool | hasLocalValue ()
| Returns true if this variable's value has been shadowed by a local assignment (as created via make_local_value()), or false otherwise.
bool | hasValue ()
| Returns true if this variable has an explicit value, either from a prc file or locally set, or false if variable has its default value.
bool | isClosed ()
| Returns true if the variable is not trusted by any prc file (and hence cannot be modified from its compiled-in default value), or false for the normal case, in which the variable can be modified by any prc file at or above its trust level (see get_trust_level()).
bool | isDynamic ()
| Returns true if the variable was indicated as "dynamic" by its constructor, indicating that its name was dynamically generated, possibly from a large pool, and it should not be listed along with the other variables.
| output (ostream out)
| write (ostream out)

## Detailed Description

This class is the base class for both ConfigVariableList and ConfigVariable (and hence for all of the ConfigVariableBool, ConfigVaribleString, etc.

classes). It collects together the common interface for all generic ConfigVariables.

Mostly, this class serves as a thin wrapper around ConfigVariableCore and/or ConfigDeclaration, more or less duplicating the interface presented there.

## Member Function Documentation

bool clearLocalValue | ( |  | ) |

Removes the local value defined for this variable, and allows its value to be once again retrieved from the .prc files.

Returns true if the value was successfully removed, false if it did not exist in the first place.

Reimplemented in ConfigVariableSearchPath.

string getDescription | ( |  | ) |

Returns the brief description of this variable, if it has been defined.

int getFlags | ( |  | ) |

Returns the flags value as set by set_flags().

This includes the trust level and some other settings. See the individual methods is_closed(), get_trust_level(), etc. to pull out the semantic meaning of these flags individually.

string getName | ( |  | ) |

Returns the name of the variable.

int getTrustLevel | ( |  | ) |

Returns the minimum trust_level a prc file must demonstrate in order to redefine the value for this variable.

Arguably, this should be called the "mistrust level", since the larger the value, the more suspicious we are of prc files. This value is not used if is_closed() returns true, which indicates no file may be trusted.

This value only has effect in a release build (specifically, when PRC_RESPECT_TRUST_LEVEL is defined true in Config.pp).

ValueType getValueType | ( |  | ) |

Returns the stated type of this variable.

This should be VT_list, unless a later variable declaration has changed it.

bool hasLocalValue | ( |  | ) |

Returns true if this variable's value has been shadowed by a local assignment (as created via make_local_value()), or false otherwise.

bool hasValue | ( |  | ) |

Returns true if this variable has an explicit value, either from a prc file or locally set, or false if variable has its default value.

bool isClosed | ( |  | ) |

Returns true if the variable is not trusted by any prc file (and hence cannot be modified from its compiled-in default value), or false for the normal case, in which the variable can be modified by any prc file at or above its trust level (see get_trust_level()).

This value only has effect in a release build (specifically, when PRC_RESPECT_TRUST_LEVEL is defined true in Config.pp).

bool isDynamic | ( |  | ) |

Returns true if the variable was indicated as "dynamic" by its constructor, indicating that its name was dynamically generated, possibly from a large pool, and it should not be listed along with the other variables.

output | ( | ostream | out | ) |

Reimplemented in ConfigVariableList, and ConfigVariableSearchPath.

write | ( | ostream | out | ) |

Reimplemented in ConfigVariableList, and ConfigVariableSearchPath.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties